diff --git a/src/main/java/net/minecraft/server/net/handler/NetServerHandler.java b/src/main/java/net/minecraft/server/net/handler/ServerPacketHandler.java
similarity index 67%
rename from src/main/java/net/minecraft/server/net/handler/NetServerHandler.java
rename to src/main/java/net/minecraft/server/net/handler/ServerPacketHandler.java
index a78c6a067..4b2550d1f 100644
--- a/src/main/java/net/minecraft/server/net/handler/NetServerHandler.java
+++ b/src/main/java/net/minecraft/server/net/handler/ServerPacketHandler.java
@@ -1,22 +1,17 @@
 package net.minecraft.server.net.handler;
 
-import java.nio.charset.StandardCharsets;
-import java.util.ArrayList;
-import java.util.HashMap;
-import java.util.Map;
-
-import net.minecraft.core.HitResult;
-import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.block.entity.TileEntityFlag;
-import net.minecraft.core.block.entity.TileEntityMobSpawner;
-import net.minecraft.core.block.entity.TileEntitySign;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.FlagBlockEntity;
+import net.minecraft.core.block.entity.MobSpawnerBlockEntity;
+import net.minecraft.core.block.entity.SignBlockEntity;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.vehicle.EntityBoat;
+import net.minecraft.core.entity.vehicle.BoatEntity;
 import net.minecraft.core.enums.ArtType;
 import net.minecraft.core.enums.EnumSignPicture;
 import net.minecraft.core.enums.PlacementMode;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.net.ChatEmotes;
 import net.minecraft.core.net.ICommandListener;
 import net.minecraft.core.net.NetworkManager;
 import net.minecraft.core.net.command.Command;
@@ -26,41 +21,38 @@ import net.minecraft.core.net.command.PlayerCommandSender;
 import net.minecraft.core.net.command.ServerCommandHandler;
 import net.minecraft.core.net.command.ServerPlayerCommandSender;
 import net.minecraft.core.net.command.TextFormatting;
-import net.minecraft.core.net.handler.NetHandler;
+import net.minecraft.core.net.handler.PacketHandler;
+import net.minecraft.core.net.packet.ChatPacket;
+import net.minecraft.core.net.packet.PlayerCommandPacket;
+import net.minecraft.core.net.packet.InteractPacket;
+import net.minecraft.core.net.packet.KeepAlivePacket;
+import net.minecraft.core.net.packet.MovePlayerPacket;
 import net.minecraft.core.net.packet.Packet;
-import net.minecraft.core.net.packet.Packet0KeepAlive;
-import net.minecraft.core.net.packet.Packet101CloseWindow;
-import net.minecraft.core.net.packet.Packet102WindowClick;
-import net.minecraft.core.net.packet.Packet103SetSlot;
-import net.minecraft.core.net.packet.Packet106Transaction;
-import net.minecraft.core.net.packet.Packet107UpdateCreativeInventory;
-import net.minecraft.core.net.packet.Packet108SetHotbarOffset;
-import net.minecraft.core.net.packet.Packet10Flying;
-import net.minecraft.core.net.packet.Packet11PlayerPosition;
-import net.minecraft.core.net.packet.Packet130UpdateSign;
-import net.minecraft.core.net.packet.Packet132SetMobSpawner;
-import net.minecraft.core.net.packet.Packet133OpenGuidebook;
-import net.minecraft.core.net.packet.Packet137SetItemName;
-import net.minecraft.core.net.packet.Packet139SetPaintingMotive;
-import net.minecraft.core.net.packet.Packet13PlayerLookMove;
-import net.minecraft.core.net.packet.Packet14BlockDig;
-import net.minecraft.core.net.packet.Packet15Place;
-import net.minecraft.core.net.packet.Packet16BlockItemSwitch;
-import net.minecraft.core.net.packet.Packet18Animation;
-import net.minecraft.core.net.packet.Packet19EntityAction;
-import net.minecraft.core.net.packet.Packet250CustomPayload;
-import net.minecraft.core.net.packet.Packet255KickDisconnect;
-import net.minecraft.core.net.packet.Packet26BoatControl;
-import net.minecraft.core.net.packet.Packet27Position;
-import net.minecraft.core.net.packet.Packet3Chat;
-import net.minecraft.core.net.packet.Packet53BlockChange;
-import net.minecraft.core.net.packet.Packet72UpdatePlayerProfile;
-import net.minecraft.core.net.packet.Packet7UseEntity;
-import net.minecraft.core.net.packet.Packet9Respawn;
+import net.minecraft.core.net.packet.ContainerClosePacket;
+import net.minecraft.core.net.packet.ContainerClickPacket;
+import net.minecraft.core.net.packet.ContainerSetSlotPacket;
+import net.minecraft.core.net.packet.ContainerAckPacket;
+import net.minecraft.core.net.packet.UpdateCreativeInventoryPacket;
+import net.minecraft.core.net.packet.SetHotbarOffsetPacket;
+import net.minecraft.core.net.packet.SignUpdatePacket;
+import net.minecraft.core.net.packet.SetMobSpawnerPacket;
+import net.minecraft.core.net.packet.GuidebookPacket;
+import net.minecraft.core.net.packet.SetItemNamePacket;
+import net.minecraft.core.net.packet.SetPaintingArtPacket;
+import net.minecraft.core.net.packet.PlayerActionPacket;
+import net.minecraft.core.net.packet.UseItemPacket;
+import net.minecraft.core.net.packet.SetCarriedItemPacket;
+import net.minecraft.core.net.packet.AnimatePacket;
+import net.minecraft.core.net.packet.CustomPayloadPacket;
+import net.minecraft.core.net.packet.DisconnectPacket;
+import net.minecraft.core.net.packet.BoatControlPacket;
+import net.minecraft.core.net.packet.BlockUpdatePacket;
+import net.minecraft.core.net.packet.UpdatePlayerProfilePacket;
+import net.minecraft.core.net.packet.RespawnPacket;
 import net.minecraft.core.player.gamemode.Gamemode;
-import net.minecraft.core.player.inventory.ContainerFlag;
-import net.minecraft.core.player.inventory.ContainerPlayerCreative;
-import net.minecraft.core.player.inventory.InventoryPlayer;
+import net.minecraft.core.player.inventory.menu.FlagMenu;
+import net.minecraft.core.player.inventory.menu.CreativeInventoryMenu;
+import net.minecraft.core.player.inventory.container.Inventory;
 import net.minecraft.core.player.inventory.slot.Slot;
 import net.minecraft.core.util.helper.AES;
 import net.minecraft.core.util.helper.ChatAllowedCharacters;
@@ -68,33 +60,25 @@ import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.RestHandler;
 import net.minecraft.core.util.phys.AABB;
-import net.minecraft.core.util.phys.Vec3d;
+import net.minecraft.core.util.phys.HitResult;
+import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
 import net.minecraft.server.MinecraftServer;
-import net.minecraft.server.entity.player.EntityPlayerMP;
-import net.minecraft.core.net.ChatEmotes;
+import net.minecraft.server.entity.player.ServerPlayer;
 import net.minecraft.server.util.helper.PlayerList;
 import net.minecraft.server.world.WorldServer;
 import org.apache.log4j.Logger;
 
+import java.nio.charset.StandardCharsets;
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.Map;
 
-// Referenced classes of package net.minecraft.src:
-//            NetHandler, ICommandListener, NetworkManager, EntityPlayerMP, 
-//            Packet0KeepAlive, Packet255KickDisconnect, Packet3Chat, ServerConfigurationManager, 
-//            Packet27Position, Packet10Flying, Entity, WorldServer, 
-//            AxisAlignedBB, Packet13PlayerLookMove, Packet14BlockDig, WorldProvider, 
-//            ChunkCoordinates, MathHelper, ItemInWorldManager, Packet53BlockChange, 
-//            InventoryPlayer, Packet15Place, ItemStack, Container, 
-//            Packet103SetSlot, Slot, Packet16BlockItemSwitch, ChatAllowedCharacters, 
-//            Packet18Animation, Packet19EntityAction, Packet7UseEntity, Packet102WindowClick, 
-//            Packet106Transaction, Packet130UpdateSign, TileEntitySign, Packet, 
-//            Packet9Respawn, Packet101CloseWindow
-
-public class NetServerHandler extends NetHandler
+public class ServerPacketHandler extends PacketHandler
         implements ICommandListener
 {
 
-    public NetServerHandler(MinecraftServer minecraftserver, NetworkManager networkManager, EntityPlayerMP player)
+    public ServerPacketHandler(MinecraftServer minecraftserver, NetworkManager networkManager, ServerPlayer player)
     {
         connectionClosed = false;
         hasMoved = true;
@@ -112,17 +96,17 @@ public class NetServerHandler extends NetHandler
         netManager.processReadPackets();
         if (field_15_f - field_22004_g > 20)
         {
-            sendPacket(new Packet0KeepAlive());
+            sendPacket(new KeepAlivePacket());
         }
     }
 
     public void kickPlayer(String s)
     {
         playerEntity.func_30002_A();
-        sendPacket(new Packet255KickDisconnect(s));
+        sendPacket(new DisconnectPacket(s));
         netManager.serverShutdown();
-        mcServer.playerList.sendPacketToAllPlayers(new Packet3Chat(playerEntity.getDisplayName() + TextFormatting.YELLOW + " was kicked from the game."));
-        mcServer.playerList.sendPacketToAllPlayers(new Packet72UpdatePlayerProfile(playerEntity.username, playerEntity.nickname, playerEntity.score, playerEntity.chatColor, false, playerEntity.isOperator()));
+        mcServer.playerList.sendPacketToAllPlayers(new ChatPacket(playerEntity.getDisplayName() + TextFormatting.YELLOW + " was kicked from the game."));
+        mcServer.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(playerEntity.username, playerEntity.nickname, playerEntity.score, playerEntity.chatColor, false, playerEntity.isOperator()));
         mcServer.playerList.playerLoggedOut(playerEntity);
         connectionClosed = true;
         if (MinecraftServer.statsStatus)
@@ -132,30 +116,25 @@ public class NetServerHandler extends NetHandler
         PlayerList.updateList();
     }
 
-    public void handleMovementTypePacket(Packet27Position packet)
-    {
-        playerEntity.setMovementType(packet.func_22031_c(), packet.func_22028_e(), packet.func_22032_g(), packet.func_22030_h(), packet.func_22029_d(), packet.func_22033_f());
-    }
-
     @Override
-    public void handleSetMobSpawner(Packet132SetMobSpawner packet) {
+    public void handleSetMobSpawner(SetMobSpawnerPacket packet) {
         WorldServer world = mcServer.getDimensionWorld(playerEntity.dimension);
         if (playerEntity.getGamemode() == Gamemode.creative && world.isBlockLoaded(packet.xPosition, packet.yPosition, packet.zPosition))
         {
-            TileEntity tileentity = world.getBlockTileEntity(packet.xPosition, packet.yPosition, packet.zPosition);
-            if (tileentity instanceof TileEntityMobSpawner)
+            BlockEntity tileentity = world.getBlockEntity(packet.xPosition, packet.yPosition, packet.zPosition);
+            if (tileentity instanceof MobSpawnerBlockEntity)
             {
-                TileEntityMobSpawner tileEntityMobSpawner = (TileEntityMobSpawner) tileentity;
+                MobSpawnerBlockEntity tileEntityMobSpawner = (MobSpawnerBlockEntity) tileentity;
                 tileEntityMobSpawner.setMobId(packet.spawnType);
 
-                tileEntityMobSpawner.onInventoryChanged();
+                tileEntityMobSpawner.setChanged();
                 world.markBlockNeedsUpdate(packet.xPosition, packet.yPosition, packet.zPosition);
             }
         }
     }
 
     @Override
-    public void handleFlying(Packet10Flying packet)
+    public void handleFlying(MovePlayerPacket packet)
     {
         if (!playerEntity.isAlive()) return;
         WorldServer worldserver = mcServer.getDimensionWorld(playerEntity.dimension);
@@ -163,8 +142,8 @@ public class NetServerHandler extends NetHandler
         field_22003_h = true;
         if (!hasMoved)
         {
-            double d = packet.yPosition - lastPosY;
-            if (packet.xPosition == lastPosX && d * d < 0.01D && packet.zPosition == lastPosZ)
+            double d = packet.y - lastPosY;
+            if (packet.x == lastPosX && d * d < 0.01D && packet.z == lastPosZ)
             {
                 hasMoved = true;
             }
@@ -181,15 +160,15 @@ public class NetServerHandler extends NetHandler
                 double d6 = playerEntity.z;
                 double d8 = 0.0D;
                 double d9 = 0.0D;
-                if (packet.rotating)
+                if (packet.hasRotation)
                 {
                     f = packet.yaw;
                     f1 = packet.pitch;
                 }
-                if (packet.moving && packet.yPosition == -999D && packet.stance == -999D)
+                if (packet.hasPosition && packet.y == -999D && packet.yView == -999D)
                 {
-                    d8 = packet.xPosition;
-                    d9 = packet.zPosition;
+                    d8 = packet.x;
+                    d9 = packet.z;
                 }
                 playerEntity.onGround = packet.onGround;
                 playerEntity.onUpdateEntity();
@@ -228,19 +207,19 @@ public class NetServerHandler extends NetHandler
             double newPosZ = playerEntity.z;
             float f2 = playerEntity.yRot;
             float f3 = playerEntity.xRot;
-            if (packet.moving && packet.yPosition == -999D && packet.stance == -999D)
+            if (packet.hasPosition && packet.y == -999D && packet.yView == -999D)
             {
-                packet.moving = false;
+                packet.hasPosition = false;
             }
-            if (packet.moving && packet.yPosition == -999D && packet.stance == -999D)
+            if (packet.hasPosition && packet.y == -999D && packet.yView == -999D)
             {
-                packet.moving = false;
+                packet.hasPosition = false;
             }
-            if (packet.moving)
+            if (packet.hasPosition)
             {
-                newPosX = packet.xPosition;
-                newPosY = packet.yPosition;
-                newPosZ = packet.zPosition;
+                newPosX = packet.x;
+                newPosY = packet.y;
+                newPosZ = packet.z;
                 // I don't see why the server really needs to care about stance
 //                double d10 = packet.stance - packet.yPosition;
 //                if (!playerEntity.isPlayerSleeping() && (d10 > 1.65D || d10 < 0.1D))
@@ -249,7 +228,7 @@ public class NetServerHandler extends NetHandler
 //                    return;
 //                }
                 // Lag back the player if they attempt to move to an illegal position
-                if (java.lang.Math.abs(packet.xPosition) > 32000000D || java.lang.Math.abs(packet.zPosition) > 32000000D)
+                if (java.lang.Math.abs(packet.x) > 32000000D || java.lang.Math.abs(packet.z) > 32000000D)
                 {
 //                    kickPlayer("Illegal position");
                     logger.warn((new StringBuilder()).append(playerEntity.username).append(" tried to move to an illegal position").toString());
@@ -257,7 +236,7 @@ public class NetServerHandler extends NetHandler
                     return;
                 }
             }
-            if (packet.rotating)
+            if (packet.hasRotation)
             {
                 f2 = packet.yaw;
                 f3 = packet.pitch;
@@ -307,7 +286,7 @@ public class NetServerHandler extends NetHandler
                 teleportAndRotate(lastPosX, lastPosY, lastPosZ, f2, f3);
                 return;
             }
-            AABB axisalignedbb = playerEntity.bb.copy().expand(f4, f4, f4).addCoord(0.0D, -0.55D, 0.0D);
+            AABB axisalignedbb = playerEntity.bb.copy().grow(f4, f4, f4).expand(0.0D, -0.55D, 0.0D);
             if (!playerEntity.getGamemode().canPlayerFly() && !mcServer.allowFlight && !worldserver.getIsAnySolidGround(axisalignedbb))
             {
                 if (dy > -0.03125D)
@@ -340,7 +319,7 @@ public class NetServerHandler extends NetHandler
 		lastPosY = y;
 		lastPosZ = z;
 		playerEntity.absMoveTo(x, y, z, playerEntity.yRot, playerEntity.xRot);
-		playerEntity.playerNetServerHandler.sendPacket(new Packet11PlayerPosition(x, y + 1.625, y, z, false));
+		playerEntity.playerNetServerHandler.sendPacket(new MovePlayerPacket.Pos(x, y + 1.625, y, z, false));
 	}
 
 	public void teleportAndRotate(double x, double y, double z, float yaw, float pitch) {
@@ -349,11 +328,11 @@ public class NetServerHandler extends NetHandler
 		lastPosY = y;
 		lastPosZ = z;
 		playerEntity.absMoveTo(x, y, z, yaw, pitch);
-		playerEntity.playerNetServerHandler.sendPacket(new Packet13PlayerLookMove(x, y + 1.625, y, z, yaw, pitch, false));
+		playerEntity.playerNetServerHandler.sendPacket(new MovePlayerPacket.PosRot(x, y + 1.625, y, z, yaw, pitch, false));
 	}
 
     @Override
-    public void handleBlockDig(Packet14BlockDig packet) {
+    public void handleBlockDig(PlayerActionPacket packet) {
         final int x = packet.xPosition;
         final int y = packet.yPosition;
         final int z = packet.zPosition;
@@ -390,7 +369,7 @@ public class NetServerHandler extends NetHandler
         int spawnDistZ = (int) MathHelper.abs(z - spawnPos.z);
         int distanceFromSpawn = Math.max(spawnDistX, spawnDistZ);
         if(distanceFromSpawn <= mcServer.spawnProtectionRange && !ignoreSpawnProtection) {
-            playerEntity.playerNetServerHandler.sendPacket(new Packet53BlockChange(x, y, z, world));
+            playerEntity.playerNetServerHandler.sendPacket(new BlockUpdatePacket(x, y, z, world));
             world.field_819_z = false;
             return;
         }
@@ -405,7 +384,7 @@ public class NetServerHandler extends NetHandler
         } else if(packet.status == 2) {
             // Block Destroy
             if(!playerEntity.playerController.destroyBlock(x, y, z, packet.side)) {
-                playerEntity.playerNetServerHandler.sendPacket(new Packet53BlockChange(x, y, z, world));
+                playerEntity.playerNetServerHandler.sendPacket(new BlockUpdatePacket(x, y, z, world));
             }
         }
         world.field_819_z = false;
@@ -413,14 +392,14 @@ public class NetServerHandler extends NetHandler
 
     public void handleSendInitialPlayerList()
     {
-        for (EntityPlayerMP entityPlayerMP : mcServer.playerList.playerEntities)
+        for (ServerPlayer entityPlayerServer : mcServer.playerList.playerEntities)
         {
-            sendPacket(new Packet72UpdatePlayerProfile(entityPlayerMP.username, entityPlayerMP.nickname, entityPlayerMP.score, entityPlayerMP.chatColor, true, entityPlayerMP.isOperator()));
+            sendPacket(new UpdatePlayerProfilePacket(entityPlayerServer.username, entityPlayerServer.nickname, entityPlayerServer.score, entityPlayerServer.chatColor, true, entityPlayerServer.isOperator()));
         }
     }
 
     @Override
-    public void handlePlace(Packet15Place packet)
+    public void handlePlace(UseItemPacket packet)
     {
         if (!playerEntity.getGamemode().canInteract() || !playerEntity.isAlive()) return;
         WorldServer worldserver = mcServer.getDimensionWorld(playerEntity.dimension);
@@ -453,11 +432,11 @@ public class NetServerHandler extends NetHandler
             {
                 playerEntity.playerController.activateBlockOrUseItem(playerEntity, worldserver, itemstack, x, y, z, direction.getSide(), xPlaced, yPlaced);
             }
-            playerEntity.playerNetServerHandler.sendPacket(new Packet53BlockChange(x, y, z, worldserver));
+            playerEntity.playerNetServerHandler.sendPacket(new BlockUpdatePacket(x, y, z, worldserver));
             x += direction.getOffsetX();
             y += direction.getOffsetY();
             z += direction.getOffsetZ();
-            playerEntity.playerNetServerHandler.sendPacket(new Packet53BlockChange(x, y, z, worldserver));
+            playerEntity.playerNetServerHandler.sendPacket(new BlockUpdatePacket(x, y, z, worldserver));
         }
         itemstack = playerEntity.inventory.getCurrentItem();
         if (itemstack != null && itemstack.stackSize <= 0)
@@ -466,12 +445,12 @@ public class NetServerHandler extends NetHandler
         }
         playerEntity.isChangingQuantityOnly = true;
         playerEntity.inventory.mainInventory[playerEntity.inventory.currentItem] = ItemStack.copyItemStack(playerEntity.inventory.mainInventory[playerEntity.inventory.currentItem]);
-        Slot slot = playerEntity.craftingInventory.func_20127_a(playerEntity.inventory, playerEntity.inventory.currentItem);
-        playerEntity.craftingInventory.updateInventory();
+        Slot slot = playerEntity.craftingInventory.getSlotFor(playerEntity.inventory, playerEntity.inventory.currentItem);
+        playerEntity.craftingInventory.broadcastChanges();
         playerEntity.isChangingQuantityOnly = false;
         if (!ItemStack.areItemStacksEqual(playerEntity.inventory.getCurrentItem(), packet.itemStack))
         {
-            sendPacket(new Packet103SetSlot(playerEntity.craftingInventory.windowId, slot.id, playerEntity.inventory.getCurrentItem()));
+            sendPacket(new ContainerSetSlotPacket(playerEntity.craftingInventory.containerId, slot.index, playerEntity.inventory.getCurrentItem()));
         }
         worldserver.field_819_z = false;
     }
@@ -480,8 +459,8 @@ public class NetServerHandler extends NetHandler
     public void handleErrorMessage(String s, Object[] aobj)
     {
         logger.info(playerEntity.username + " lost connection: " + s);
-        mcServer.playerList.sendPacketToAllPlayers(new Packet3Chat(playerEntity.getDisplayName() + TextFormatting.YELLOW + " left the game."));
-        mcServer.playerList.sendPacketToAllPlayers(new Packet72UpdatePlayerProfile(playerEntity.username, playerEntity.nickname, playerEntity.score, playerEntity.chatColor, false, playerEntity.isOperator()));
+        mcServer.playerList.sendPacketToAllPlayers(new ChatPacket(playerEntity.getDisplayName() + TextFormatting.YELLOW + " left the game."));
+        mcServer.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(playerEntity.username, playerEntity.nickname, playerEntity.score, playerEntity.chatColor, false, playerEntity.isOperator()));
         mcServer.playerList.playerLoggedOut(playerEntity);
         connectionClosed = true;
         if (MinecraftServer.statsStatus)
@@ -505,9 +484,9 @@ public class NetServerHandler extends NetHandler
     }
 
     @Override
-    public void handleBlockItemSwitch(Packet16BlockItemSwitch packet)
+    public void handleBlockItemSwitch(SetCarriedItemPacket packet)
     {
-        if (packet.id < 0 || packet.id > InventoryPlayer.func_25054_e())
+        if (packet.id < 0 || packet.id > Inventory.func_25054_e())
         {
             logger.warn(playerEntity.username + " tried to set an invalid carried item");
             return;
@@ -520,13 +499,13 @@ public class NetServerHandler extends NetHandler
     }
 
 	@Override
-	public void handleChat(Packet3Chat packet) {
+	public void handleChat(ChatPacket packet) {
 		String message;
 		if(packet.encrypted) {
 			try {
 				message = AES.decrypt(packet.message, AES.keyChain.get(playerEntity.username));
 			}catch (Exception e) {
-				throw new RuntimeException(Packet3Chat.ENCRYPTION_ERROR_MESSAGE, e);
+				throw new RuntimeException(ChatPacket.ENCRYPTION_ERROR_MESSAGE, e);
 			}
 		}else {
 			message = packet.message;
@@ -542,7 +521,7 @@ public class NetServerHandler extends NetHandler
 		for(int i = 0; i < message.length(); i++) {
 			char c = message.charAt(i);
 			if(ChatAllowedCharacters.ALLOWED_CHARACTERS.indexOf(c) < 0) {
-				sendPacket(new Packet3Chat(String.valueOf(TextFormatting.GRAY) + TextFormatting.ITALIC + "[SERVER] Illegal characters in chat message."));
+				sendPacket(new ChatPacket(String.valueOf(TextFormatting.GRAY) + TextFormatting.ITALIC + "[SERVER] Illegal characters in chat message."));
 				return;
 			}
 		}
@@ -598,40 +577,11 @@ public class NetServerHandler extends NetHandler
                 return;
             }
         }
-        if (s.toLowerCase().startsWith("/kill"))
-        {
-            playerEntity.hurt(null, 1000, null);
-        }
-        else if (s.equalsIgnoreCase("/online"))
-        {
-            StringBuilder playerList = new StringBuilder();
-            for (int i = 0; i < mcServer.playerList.playerEntities.size(); i++)
-            {
-                if (i > 0)
-                {
-                    playerList.append(",");
-                }
-                EntityPlayerMP entityplayermp = mcServer.playerList.playerEntities.get(i);
-                playerList.append(entityplayermp.getDisplayName()).append(": ").append(TextFormatting.YELLOW).append(entityplayermp.score).append("pts").append(TextFormatting.WHITE);
-            }
-            logger.info(s);
-            sendPacket(new Packet3Chat(playerList.toString()));
-        }
-        else if (mcServer.playerList.isOp(playerEntity.username))
-        {
-            String s1 = s.substring(1);
-            logger.info(playerEntity.username + " issued server command: " + s1);
-            mcServer.addCommand(s1, this);
-        }
-        else
-        {
-            String s2 = s.substring(1);
-            logger.info(playerEntity.username + " tried command: " + s2);
-        }
+        sender.sendMessage(TextFormatting.RED + "Command '" + args[0] + "' does not exist!");
     }
 
     @Override
-    public void handleAnimation(Packet18Animation packet)
+    public void handleAnimation(AnimatePacket packet)
     {
         if (!playerEntity.isAlive()) return;
         if (packet.animate == 1)
@@ -641,7 +591,7 @@ public class NetServerHandler extends NetHandler
     }
 
     @Override
-    public void handleEntityAction(Packet19EntityAction packet)
+    public void handleEntityAction(PlayerCommandPacket packet)
     {
         if (!playerEntity.isAlive()) return;
         if (packet.state == 1)
@@ -659,19 +609,19 @@ public class NetServerHandler extends NetHandler
         }
     }
     @Override
-    public void handleBoatControl(Packet26BoatControl packet26BoatControl)
+    public void handleBoatControl(BoatControlPacket boatControlPacket)
     {
         if (!playerEntity.getGamemode().canInteract() || !playerEntity.isAlive()) return;
-        if (playerEntity.vehicle != null && playerEntity.vehicle instanceof EntityBoat){
-            EntityBoat boat = (EntityBoat) playerEntity.vehicle;
-            boat.handleControlDirect(packet26BoatControl.targetXD, packet26BoatControl.targetZD, packet26BoatControl.targetYRot);
-            packet26BoatControl.entityId = boat.id;
-            mcServer.playerList.sendPacketToOtherPlayersAroundPoint(playerEntity,boat.x, boat.y, boat.z, 128, boat.world.dimension.id, packet26BoatControl);
+        if (playerEntity.vehicle != null && playerEntity.vehicle instanceof BoatEntity){
+            BoatEntity boat = (BoatEntity) playerEntity.vehicle;
+            boat.handleControlDirect(boatControlPacket.targetXD, boatControlPacket.targetZD, boatControlPacket.targetYRot);
+            boatControlPacket.entityId = boat.id;
+            mcServer.playerList.sendPacketToOtherPlayersAroundPoint(playerEntity,boat.x, boat.y, boat.z, 128, boat.world.dimension.id, boatControlPacket);
         }
     }
 
     @Override
-    public void handleKickDisconnect(Packet255KickDisconnect packet)
+    public void handleKickDisconnect(DisconnectPacket packet)
     {
         netManager.networkShutdown("disconnect.quitting", new Object[0]);
     }
@@ -684,7 +634,7 @@ public class NetServerHandler extends NetHandler
     @Override
     public void log(String s)
     {
-        sendPacket(new Packet3Chat("\2477" + s));
+        sendPacket(new ChatPacket("\2477" + s));
     }
 
     @Override
@@ -694,44 +644,44 @@ public class NetServerHandler extends NetHandler
     }
 
     @Override
-    public void handleUseEntity(Packet7UseEntity packet)
+    public void handleUseEntity(InteractPacket packet)
     {
         if (!playerEntity.getGamemode().canInteract() || !playerEntity.isAlive()) return;
         WorldServer worldserver = mcServer.getDimensionWorld(playerEntity.dimension);
-        Entity targetEntity = worldserver.getEntityFromId(packet.targetEntity);
+        Entity targetEntity = worldserver.getEntityFromId(packet.targetEntityID);
         if (targetEntity != null && playerEntity.distanceToSqr(targetEntity) < 36D)
         {
             boolean canAttack = playerEntity.canEntityBeSeen(targetEntity);
 
             if (!canAttack)
             {
-                float f1 = MathHelper.cos(-playerEntity.yRot * 0.01745329F - 3.141593F);
-                float f2 = MathHelper.sin(-playerEntity.yRot * 0.01745329F - 3.141593F);
+                float f1 = MathHelper.cos(-playerEntity.yRot * 0.01745329F - MathHelper.PI);
+                float f2 = MathHelper.sin(-playerEntity.yRot * 0.01745329F - MathHelper.PI);
                 float f3 = -MathHelper.cos(-playerEntity.xRot * 0.01745329F);
                 float f4 = MathHelper.sin(-playerEntity.xRot * 0.01745329F);
 
-                Vec3d viewVector = Vec3d.createVector(f2 * f3, f4, f1 * f3);
+                Vec3 viewVector = Vec3.getTempVec3(f2 * f3, f4, f1 * f3);
 
-                viewVector.xCoord *= 8;
-                viewVector.yCoord *= 8;
-                viewVector.zCoord *= 8;
-                viewVector.xCoord += playerEntity.x;
-                viewVector.yCoord += playerEntity.y;
-                viewVector.zCoord += playerEntity.z;
+                viewVector.x *= 8;
+                viewVector.y *= 8;
+                viewVector.z *= 8;
+                viewVector.x += playerEntity.x;
+                viewVector.y += playerEntity.y;
+                viewVector.z += playerEntity.z;
 
-                Vec3d playerViewPos = Vec3d.createVector(playerEntity.x, playerEntity.y + playerEntity.getHeadHeight(), playerEntity.z);
+                Vec3 playerViewPos = Vec3.getTempVec3(playerEntity.x, playerEntity.y + playerEntity.getHeadHeight(), playerEntity.z);
 
-                HitResult movingObjectPosition = targetEntity.bb.func_1169_a(playerViewPos, viewVector);
+                HitResult movingObjectPosition = targetEntity.bb.clip(playerViewPos, viewVector);
 
                 canAttack = movingObjectPosition != null && worldserver.checkBlockCollisionBetweenPoints(playerViewPos, movingObjectPosition.location) == null;
             }
             if (canAttack)
             {
-                if (packet.isLeftClick == 0)
+                if (packet.action == InteractPacket.ACTION_INTERACT)
                 {
                     playerEntity.useCurrentItemOnEntity(targetEntity);
                 }
-                else if (packet.isLeftClick == 1)
+                else if (packet.action == InteractPacket.ACTION_ATTACK)
                 {
                     playerEntity.attackTargetEntityWithCurrentItem(targetEntity);
                 }
@@ -740,13 +690,13 @@ public class NetServerHandler extends NetHandler
     }
 
     @Override
-    public void handleOpenGuidebook(Packet133OpenGuidebook packet)
+    public void handleOpenGuidebook(GuidebookPacket packet)
     {
         playerEntity.displayGUIGuidebook();
     }
 
     @Override
-    public void handleRespawn(Packet9Respawn packet)
+    public void handleRespawn(RespawnPacket packet)
     {
         if (playerEntity.getHealth() <= 0) {
             playerEntity = mcServer.playerList.recreatePlayerEntity(playerEntity, 0);
